package ru.dusystems.aopportlets.genclasses;

import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.SAXException;
import org.xml.sax.Attributes;

import java.util.*;

/**
 * @author omikheev
 * @version $Id: AopSaxHandler.java,v 1.2 2008/09/15 06:21:21 cvsmihel Exp $
 */
public class AopSaxHandler extends DefaultHandler {

	private Map<String,Set> mpClassMethod;
    private boolean inPortlet = false;
    private boolean inPortletClass = false;
    private boolean inPortletMode = false;
    private String currentPortletClass;
    private String currentMode;

    public AopSaxHandler() {
		mpClassMethod = new HashMap<String,Set>();
	}

	@Override
	public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
        if("portlet".equalsIgnoreCase(localName)) {
            inPortlet = true;
        }
        if("portlet-class".equalsIgnoreCase(localName) && inPortlet) {
            inPortletClass = true;
            currentPortletClass = "";
        }
        if("portlet-mode".equalsIgnoreCase(localName) && inPortlet) {
            inPortletMode = true;
            currentMode = "";
		}
	}

    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException {
        if("portlet".equalsIgnoreCase(localName)) {
            inPortlet = false;
        }
        if("portlet-class".equalsIgnoreCase(localName) && inPortlet) {
            inPortletClass = false;
        }
        if("portlet-mode".equalsIgnoreCase(localName) && inPortlet) {
            inPortletMode = false;
            Set st = mpClassMethod.get(currentPortletClass);
            if(st==null) {
                st = new HashSet();
                mpClassMethod.put(currentPortletClass, st);
            }
            st.add(currentMode);
		}
    }

    @Override
    public void characters(char[] ch, int start, int length) throws SAXException {
        if(inPortletClass) {
            currentPortletClass = currentPortletClass + new String(Arrays.copyOfRange(ch, start, start+length));
        } else if(inPortletMode) {
            currentMode = currentMode + new String(Arrays.copyOfRange(ch, start, start+length));
        }
    }

    public Map<String, Set> getPortletModes() {
		return mpClassMethod;
	}
}
