package ru.dusystems.aopportlets.genclasses;

import java.util.Map;
import java.util.HashMap;
import java.text.MessageFormat;

/**
 * @author omikheev
 * @version $Id: ClassSrcGenerator.java,v 1.3 2008/09/16 20:28:19 cvsmihel Exp $
 */
public class ClassSrcGenerator {

    private static final Map mp = new HashMap();
    static {
        mp.put("altview","view");
    }

	public static final String tmplClassStart = "package {0};\n\nimport ru.spbstu.ecd.ics.aopportlet168.PortletAspect;\n" +
            "import javax.portlet.*;\n\n" +
            "public class {1} extends PortletAspect '{'\n";
	public static final String tmplMethods = "\tprotected void render(RenderRequest req, RenderResponse resp, PortletContext ctx) {\n" +
            "\t}\n\n\tprotected void processAction(ActionRequest req, ActionResponse resp, PortletContext ctx) {\n\t}\n\n";
	public static final String tmplPortletMode = "\tprotected PortletMode[] getModes() '{'\n" +
            "\t\treturn new PortletMode[]'{'new PortletMode(\"{0}\")'}';\n\t'}'\n";
	public static final String tmplClassEnd = "}";

    public String getClassSource(String name, String mode) {
		String sPkgName = name.substring(0, name.lastIndexOf('.'));
        String sClassName = name.substring(name.lastIndexOf('.')+1);
        StringBuilder sb = new StringBuilder(MessageFormat.format(tmplClassStart, sPkgName, sClassName));
        sb.append(tmplMethods);
		sb.append(MessageFormat.format(tmplPortletMode, mode));
		sb.append(tmplClassEnd);
		return sb.toString();
	}

}
